#include "iRRAM.h"

REAL ln_gamma_approx(long p, const REAL& z)
{
// nur gueltig fr 7<z<8 //
  REAL ergebnis= (z-REAL(1)/2)*log(z)-z+log(2*pi())/2;
  
  REAL summand;
  long index= 0;
  do {
    index+=1;
    if ( index == 1) summand = 1/(z*12);
    else if ( index == 2) summand = -1/(power(z,3)*360);
    else if ( index == 3) summand =  1/(power(z,5)*1260);
    else if ( index == 4) summand = -1/(power(z,7)*1680);
    else if ( index == 5) summand =  1/(power(z,9)*1188);
    else if ( index == 6) summand = -691/(power(z,11)*360360);
    else if ( index == 7) summand =  7/(power(z,13)*1092);
    else if ( index == 8) summand = -3617/(power(z,15)*122400);
    else summand= 0.0;
    ergebnis +=summand;
  } while (not bound(abs(summand),p) );
  return ergebnis;
};

REAL ln_gamma(const REAL& x)
{
  return limit(ln_gamma_approx,x);
};

REAL gamma(const REAL& x){
   if ( 7 < x && x < 8) return exp(ln_gamma(x));
   if ( x < 7 )return gamma(x+1)/x;
   if ( x > 8 )return gamma(x-1)*(x-1);
}



void compute(){
  rwrite(gamma(REAL(1.5)),30);
  rprintf("\n");

  COMPLEX z=REAL(-10.5);
  COMPLEX z_k=REAL(1);
  REAL alpha=1.2;

  COMPLEX summe=REAL(1);
  COMPLEX summand;
     
  for( long k=1;k<= 1000; k++){
   z_k=z_k*z;
   summand=z_k/COMPLEX(gamma(alpha*k+1));
   summe=summe+summand;
    rwrite(real(summe),40); 
    rprintf("  +i* ");
    rwrite(imag(summe),10); 
    rprintf("  bei k=%d, Summand: ",k);
    rwritee(real(summand),20); 
    rprintf("\n",k);
 
  }
};

